from enum import Enum, auto


class EVENTS:
    MESSAGE_CREATE = (
        "AT_MESSAGE_CREATE",
        "MESSAGE_CREATE",
    )
    DM_CREATE = ("DIRECT_MESSAGE_CREATE",)
    GROUP_AT_MESSAGE_CREATE = ("GROUP_AT_MESSAGE_CREATE",)
    C2C_MESSAGE_CREATE = ("C2C_MESSAGE_CREATE",)
    MESSAGE_DELETE = (
        "MESSAGE_DELETE",
        "PUBLIC_MESSAGE_DELETE",
        "DIRECT_MESSAGE_DELETE",
    )
    FORUM = (
        "FORUM_THREAD_CREATE",
        "FORUM_THREAD_UPDATE",
        "FORUM_THREAD_DELETE",
        "FORUM_POST_CREATE",
        "FORUM_POST_DELETE",
        "FORUM_REPLY_CREATE",
        "FORUM_REPLY_DELETE",
        "FORUM_PUBLISH_AUDIT_RESULT",
    )
    GUILD = ("GUILD_CREATE", "GUILD_UPDATE", "GUILD_DELETE")
    CHANNEL = ("CHANNEL_CREATE", "CHANNEL_UPDATE", "CHANNEL_DELETE")
    GUILD_MEMBER = ("GUILD_MEMBER_ADD", "GUILD_MEMBER_UPDATE", "GUILD_MEMBER_REMOVE")
    REACTION = ("MESSAGE_REACTION_ADD", "MESSAGE_REACTION_REMOVE")
    INTERACTION = ("INTERACTION_CREATE",)
    AUDIT = ("MESSAGE_AUDIT_PASS", "MESSAGE_AUDIT_REJECT")
    OPEN_FORUM = (
        "OPEN_FORUM_THREAD_CREATE",
        "OPEN_FORUM_THREAD_UPDATE",
        "OPEN_FORUM_THREAD_DELETE",
        "OPEN_FORUM_POST_CREATE",
        "OPEN_FORUM_POST_DELETE",
        "OPEN_FORUM_REPLY_CREATE",
        "OPEN_FORUM_REPLY_DELETE",
    )
    AUDIO = ("AUDIO_START", "AUDIO_FINISH", "AUDIO_ON_MIC", "AUDIO_OFF_MIC")
    ALC_MEMBER = (
        "AUDIO_OR_LIVE_CHANNEL_MEMBER_ENTER",
        "AUDIO_OR_LIVE_CHANNEL_MEMBER_EXIT",
    )
    GROUP = (
        "GROUP_ADD_ROBOT",
        "GROUP_DEL_ROBOT",
        "GROUP_MSG_REJECT",
        "GROUP_MSG_RECEIVE",
    )
    FRIEND = ("FRIEND_ADD", "FRIEND_DEL", "C2C_MSG_REJECT", "C2C_MSG_RECEIVE")


class EVENTS_ENUM(Enum):
    MESSAGE_CREATE = auto()
    DM_CREATE = auto()
    GROUP_AT_MESSAGE_CREATE = auto()
    C2C_MESSAGE_CREATE = auto()
    MESSAGE_DELETE = auto()
    FORUM = auto()
    GUILD = auto()
    CHANNEL = auto()
    GUILD_MEMBER = auto()
    REACTION = auto()
    INTERACTION = auto()
    AUDIT = auto()
    OPEN_FORUM = auto()
    AUDIO = auto()
    ALC_MEMBER = auto()
    GROUP = auto()
    FRIEND = auto()


TraceNames = ("start_callback_task", "async_start_callback_task")

MsgIDEvents = (
    EVENTS.MESSAGE_CREATE
    + EVENTS.DM_CREATE
    + EVENTS.GROUP_AT_MESSAGE_CREATE
    + EVENTS.C2C_MESSAGE_CREATE
)
EventIDEvents = (
    EVENTS.GUILD_MEMBER + EVENTS.REACTION + EVENTS.FORUM + EVENTS.INTERACTION
)
